/*******************************************************************************
 *  Copyright 2017-2018 Centre for Development of Advanced Computing(C-DAC), Pune
 *  
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *  
 *   http://www.apache.org/licenses/LICENSE-2.0
 *  
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *******************************************************************************/
package cdac.medinfo.sdk.dcm30_04.templates.cid;


import cdac.medinfo.sdk.dcm30_04.templates.enums.EnumCodingSchemeDesignator;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cm.EnumCM_ImageGuidedTherapeuticProcedures;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cv.EnumCV_ImageGuidedTherapeuticProcedures;
import cdac.medinfo.sdk.dcm30_04.templates.dicomsnomedmap.EnumDICOMSNOMEDMap;

/**
 * This class represents ImageGuidedTherapeuticProcedures CID9
 */
public class ImageGuidedTherapeuticProcedures_CID9 {

	/**
	 * The Code Value for template.
	 */
	private String strCodeValue = null;

	/**
	 * The Code Meaning for template.
	 */
	private String strCodeMeaning = null;

	/**
	 * The Coding Scheme Designator for template.
	 */
	private String strCodingSchemeDesignator;

	/**
	 * The SNOMED CT ID for template.
	 */
	private String strSNOMEDCTID = null;
	/**
	 * Instantiates a new ImageGuidedTherapeuticProcedures_CID9 Template 
	 */
	public ImageGuidedTherapeuticProcedures_CID9()
	{

	}

	/**
	 * Retrieves the value for Code Meaning.
	 * @return String value for Code Meaning.
	 */
	public String getCodeMeaning()
	{
		return strCodeMeaning;
	}

	/**
	 * Retrieves the value for Code Value.
	 * @return String value for Code Value.
	 */
	public String getCodeValue() 
	{
		return strCodeValue;
	}

	/**
	 * Retrieves the value for Coding Scheme Designator.
	 * @return String value for Coding Scheme Designator.
	 */
	public String getCodingSchemeDesignator() 
	{
		return strCodingSchemeDesignator;
	}
	
	/**
	 * Retrieves the value for SNOMED-CT ID.
	 * @return String value for SNOMED-CT ID.
	 */
	public String getSNOMEDCTID() 
	{
		return strSNOMEDCTID;
	}
	/**
	 * Sets the Code Value according to Code Meaning.
	 * @param enumImageGuidedTherapeuticProcedures Object of EnumCM_ImageGuidedTherapeuticProcedures represents Code Meaning.
	 */
	private void setCodeValue(EnumCM_ImageGuidedTherapeuticProcedures enumImageGuidedTherapeuticProcedures)
	{
		switch(enumImageGuidedTherapeuticProcedures)
		{
		case VASOCONSTRICTION: this.strCodeValue =EnumCV_ImageGuidedTherapeuticProcedures.VASOCONSTRICTION_F_39780.getValue(); break;
		case VASODILATATION: this.strCodeValue =EnumCV_ImageGuidedTherapeuticProcedures.VASODILATATION_F_39800.getValue(); break;
		case BIOPSY: this.strCodeValue =EnumCV_ImageGuidedTherapeuticProcedures.BIOPSY_P1_03100.getValue(); break;
		case REMOVAL_OF_FOREIGN_BODY: this.strCodeValue =EnumCV_ImageGuidedTherapeuticProcedures.REMOVAL_OF_FOREIGN_BODY_P1_03176.getValue(); break;
		case INTRA_ARTERIAL_INFUSION_OF_THROMBOLYTIC_AGENT: this.strCodeValue =EnumCV_ImageGuidedTherapeuticProcedures.INTRA_ARTERIAL_INFUSION_OF_THROMBOLYTIC_AGENT_P1_05035.getValue(); break;
		case IRRIGATIONFOLLOWINGINSERTIONOFCATHETER: this.strCodeValue =EnumCV_ImageGuidedTherapeuticProcedures.IRRIGATIONFOLLOWINGINSERTIONOFCATHETER_P1_05052.getValue(); break;
		case CATHETERIZATION: this.strCodeValue =EnumCV_ImageGuidedTherapeuticProcedures.CATHETERIZATION_P1_05535.getValue(); break;
		case ATHERECTOMY: this.strCodeValue =EnumCV_ImageGuidedTherapeuticProcedures.ATHERECTOMY_P1_30350.getValue(); break;
		case ATHERECTOMY_BY_ROTARY_CUTTER: this.strCodeValue =EnumCV_ImageGuidedTherapeuticProcedures.ATHERECTOMY_BY_ROTARY_CUTTER_P1_30351.getValue(); break;
		case ATHERECTOMY_BY_LASER: this.strCodeValue =EnumCV_ImageGuidedTherapeuticProcedures.ATHERECTOMY_BY_LASER_P1_30352.getValue(); break;
		case SELECTIVE_EMBOLIZATION_OF_ARTERY: this.strCodeValue =EnumCV_ImageGuidedTherapeuticProcedures.SELECTIVE_EMBOLIZATION_OF_ARTERY_P1_30530.getValue(); break;
		case PERCUTANEOUS_TRANSLUMINAL_BALLOON_ANGIOPLASTY: this.strCodeValue =EnumCV_ImageGuidedTherapeuticProcedures.PERCUTANEOUS_TRANSLUMINAL_BALLOON_ANGIOPLASTY_P5_31500.getValue(); break;
		case TRANSCATHETERTHERAPYFOREMBOLIZATION: this.strCodeValue =EnumCV_ImageGuidedTherapeuticProcedures.TRANSCATHETERTHERAPYFOREMBOLIZATION_P5_39010.getValue(); break;
		case PERCUTANEOUSRETRIEVALOFINTRAVASCULAR_FOREIGNBODY: this.strCodeValue =EnumCV_ImageGuidedTherapeuticProcedures.PERCUTANEOUSRETRIEVALOFINTRAVASCULAR_FOREIGNBODY_P5_39050.getValue(); break;
		case FAILED_ATTEMPTED_PROCEDURE: this.strCodeValue =EnumCV_ImageGuidedTherapeuticProcedures.FAILED_ATTEMPTED_PROCEDURE_P1_00018.getValue(); break;
		case STENT_PLACEMENT: this.strCodeValue =EnumCV_ImageGuidedTherapeuticProcedures.STENT_PLACEMENT_P1_05550.getValue(); break;
		case CATHETER_MANIPULATION: this.strCodeValue =EnumCV_ImageGuidedTherapeuticProcedures.CATHETER_MANIPULATION_P1_05536.getValue(); break;
		case CATHETER_REPLACEMENT: this.strCodeValue =EnumCV_ImageGuidedTherapeuticProcedures.CATHETER_REPLACEMENT_P1_05537.getValue(); break;
		case OCCLUSION_OF_CATHETER: this.strCodeValue =EnumCV_ImageGuidedTherapeuticProcedures.OCCLUSION_OF_CATHETER_P1_05538.getValue(); break;
		case REMOVAL_OF_CATHETER: this.strCodeValue =EnumCV_ImageGuidedTherapeuticProcedures.REMOVAL_OF_CATHETER_P1_05539.getValue(); break;
		case TRANSCATHETER_DEPLOYMENT_OF_DETACHABLE_BALLOON: this.strCodeValue =EnumCV_ImageGuidedTherapeuticProcedures.TRANSCATHETER_DEPLOYMENT_OF_DETACHABLE_BALLOON_P5_39015.getValue(); break;
		case PERCUTANEOUSINSERTIONOFINTRAVASCULAR_FILTER: this.strCodeValue =EnumCV_ImageGuidedTherapeuticProcedures.PERCUTANEOUSINSERTIONOFINTRAVASCULAR_FILTER_P5_39191.getValue(); break;
		case AMNIOCENTESIS: this.strCodeValue =EnumCV_ImageGuidedTherapeuticProcedures.AMNIOCENTESIS_P1_86100.getValue(); break;
		case ULTRASONICGUIDANCEFORAMNIOCENTESIS: this.strCodeValue =EnumCV_ImageGuidedTherapeuticProcedures.ULTRASONICGUIDANCEFORAMNIOCENTESIS_P5_B8310.getValue(); break;
		case AMNIOINFUSION_INJECTION_OF_AMNION: this.strCodeValue =EnumCV_ImageGuidedTherapeuticProcedures.AMNIOINFUSION_INJECTION_OF_AMNION_P1_86520.getValue(); break;
		case INTRAUTERINE_CORDOCENTESIS: this.strCodeValue =EnumCV_ImageGuidedTherapeuticProcedures.INTRAUTERINE_CORDOCENTESIS_P1_86180.getValue(); break;
		case THORACENTESIS: this.strCodeValue =EnumCV_ImageGuidedTherapeuticProcedures.THORACENTESIS_P1_28160.getValue(); break;
		case BREECH_VERSION_OBSTETRICAL_VERSION: this.strCodeValue =EnumCV_ImageGuidedTherapeuticProcedures.BREECH_VERSION_OBSTETRICAL_VERSION_P1_86E70.getValue(); break;
		case DECOMPRESSION_AMNIOCENTESIS_DECOMPRESSION_OF_AMNION: this.strCodeValue =EnumCV_ImageGuidedTherapeuticProcedures.DECOMPRESSION_AMNIOCENTESIS_DECOMPRESSION_OF_AMNION_P1_86101.getValue(); break;
		case INTRAUTERINE_TRANSFUSION: this.strCodeValue =EnumCV_ImageGuidedTherapeuticProcedures.INTRAUTERINE_TRANSFUSION_P2_68060.getValue(); break;
		case FETOCIDE_SELECTIVE_REDUCTION: this.strCodeValue =EnumCV_ImageGuidedTherapeuticProcedures.FETOCIDE_SELECTIVE_REDUCTION_P1_86C50.getValue(); break;
		case PROSTAGLANDIN_INJECTION: this.strCodeValue =EnumCV_ImageGuidedTherapeuticProcedures.PROSTAGLANDIN_INJECTION_P1_93506.getValue(); break;
		}
	}

	/**
	 * Sets the SNOMED-CT ID.
	 * @param enumImageGuidedTherapeuticProcedures Object of EnumCM_ImageGuidedTherapeuticProcedures represents Code Meaning.
	 */
	private void setSNOMEDCTID(EnumCM_ImageGuidedTherapeuticProcedures enumImageGuidedTherapeuticProcedures)
	{
		switch(enumImageGuidedTherapeuticProcedures)
		{
		case VASOCONSTRICTION : this.strSNOMEDCTID =EnumDICOMSNOMEDMap.VASOCONSTRICTION.getSNOMEDCTID(); break;
		case VASODILATATION : this.strSNOMEDCTID =EnumDICOMSNOMEDMap.VASODILATATION.getSNOMEDCTID(); break;
		case BIOPSY : this.strSNOMEDCTID =EnumDICOMSNOMEDMap.BIOPSY.getSNOMEDCTID(); break;
		case REMOVAL_OF_FOREIGN_BODY : this.strSNOMEDCTID =EnumDICOMSNOMEDMap.REMOVAL_OF_FOREIGN_BODY.getSNOMEDCTID(); break;
		case INTRA_ARTERIAL_INFUSION_OF_THROMBOLYTIC_AGENT : this.strSNOMEDCTID =EnumDICOMSNOMEDMap.INTRA_ARTERIAL_INFUSION_OF_THROMBOLYTIC_AGENT.getSNOMEDCTID(); break;
		case IRRIGATIONFOLLOWINGINSERTIONOFCATHETER : this.strSNOMEDCTID =EnumDICOMSNOMEDMap.IRRIGATIONFOLLOWINGINSERTIONOFCATHETER.getSNOMEDCTID(); break;
		case CATHETERIZATION : this.strSNOMEDCTID =EnumDICOMSNOMEDMap.CATHETERIZATION.getSNOMEDCTID(); break;
		case ATHERECTOMY : this.strSNOMEDCTID =EnumDICOMSNOMEDMap.ATHERECTOMY.getSNOMEDCTID(); break;
		case ATHERECTOMY_BY_ROTARY_CUTTER : this.strSNOMEDCTID =EnumDICOMSNOMEDMap.ATHERECTOMY_BY_ROTARY_CUTTER.getSNOMEDCTID(); break;
		case ATHERECTOMY_BY_LASER : this.strSNOMEDCTID =EnumDICOMSNOMEDMap.ATHERECTOMY_BY_LASER.getSNOMEDCTID(); break;
		case SELECTIVE_EMBOLIZATION_OF_ARTERY : this.strSNOMEDCTID =EnumDICOMSNOMEDMap.SELECTIVE_EMBOLIZATION_OF_ARTERY.getSNOMEDCTID(); break;
		case PERCUTANEOUS_TRANSLUMINAL_BALLOON_ANGIOPLASTY : this.strSNOMEDCTID =EnumDICOMSNOMEDMap.PERCUTANEOUS_TRANSLUMINAL_BALLOON_ANGIOPLASTY.getSNOMEDCTID(); break;
		case TRANSCATHETERTHERAPYFOREMBOLIZATION : this.strSNOMEDCTID =EnumDICOMSNOMEDMap.TRANSCATHETERTHERAPYFOREMBOLIZATION.getSNOMEDCTID(); break;
		case PERCUTANEOUSRETRIEVALOFINTRAVASCULAR_FOREIGNBODY : this.strSNOMEDCTID =EnumDICOMSNOMEDMap.PERCUTANEOUSRETRIEVALOFINTRAVASCULAR_FOREIGNBODY.getSNOMEDCTID(); break;
		case FAILED_ATTEMPTED_PROCEDURE : this.strSNOMEDCTID =EnumDICOMSNOMEDMap.FAILED_ATTEMPTED_PROCEDURE.getSNOMEDCTID(); break;
		case STENT_PLACEMENT : this.strSNOMEDCTID =EnumDICOMSNOMEDMap.STENT_PLACEMENT.getSNOMEDCTID(); break;
		case CATHETER_MANIPULATION : this.strSNOMEDCTID =EnumDICOMSNOMEDMap.CATHETER_MANIPULATION.getSNOMEDCTID(); break;
		case CATHETER_REPLACEMENT : this.strSNOMEDCTID =EnumDICOMSNOMEDMap.CATHETER_REPLACEMENT.getSNOMEDCTID(); break;
		case OCCLUSION_OF_CATHETER : this.strSNOMEDCTID =EnumDICOMSNOMEDMap.OCCLUSION_OF_CATHETER.getSNOMEDCTID(); break;
		case REMOVAL_OF_CATHETER : this.strSNOMEDCTID =EnumDICOMSNOMEDMap.REMOVAL_OF_CATHETER.getSNOMEDCTID(); break;
		case TRANSCATHETER_DEPLOYMENT_OF_DETACHABLE_BALLOON : this.strSNOMEDCTID =EnumDICOMSNOMEDMap.TRANSCATHETER_DEPLOYMENT_OF_DETACHABLE_BALLOON.getSNOMEDCTID(); break;
		case PERCUTANEOUSINSERTIONOFINTRAVASCULAR_FILTER : this.strSNOMEDCTID =EnumDICOMSNOMEDMap.PERCUTANEOUSINSERTIONOFINTRAVASCULAR_FILTER.getSNOMEDCTID(); break;
		case AMNIOCENTESIS : this.strSNOMEDCTID =EnumDICOMSNOMEDMap.AMNIOCENTESIS.getSNOMEDCTID(); break;
		case ULTRASONICGUIDANCEFORAMNIOCENTESIS : this.strSNOMEDCTID =EnumDICOMSNOMEDMap.ULTRASONICGUIDANCEFORAMNIOCENTESIS.getSNOMEDCTID(); break;
		case AMNIOINFUSION_INJECTION_OF_AMNION : this.strSNOMEDCTID =EnumDICOMSNOMEDMap.AMNIOINFUSION_INJECTION_OF_AMNION.getSNOMEDCTID(); break;
		case INTRAUTERINE_CORDOCENTESIS : this.strSNOMEDCTID =EnumDICOMSNOMEDMap.INTRAUTERINE_CORDOCENTESIS.getSNOMEDCTID(); break;
		case THORACENTESIS : this.strSNOMEDCTID =EnumDICOMSNOMEDMap.THORACENTESIS.getSNOMEDCTID(); break;
		case BREECH_VERSION_OBSTETRICAL_VERSION : this.strSNOMEDCTID =EnumDICOMSNOMEDMap.BREECH_VERSION_OBSTETRICAL_VERSION.getSNOMEDCTID(); break;
		case DECOMPRESSION_AMNIOCENTESIS_DECOMPRESSION_OF_AMNION : this.strSNOMEDCTID =EnumDICOMSNOMEDMap.DECOMPRESSION_AMNIOCENTESIS_DECOMPRESSION_OF_AMNION.getSNOMEDCTID(); break;
		case INTRAUTERINE_TRANSFUSION : this.strSNOMEDCTID =EnumDICOMSNOMEDMap.INTRAUTERINE_TRANSFUSION.getSNOMEDCTID(); break;
		case FETOCIDE_SELECTIVE_REDUCTION : this.strSNOMEDCTID =EnumDICOMSNOMEDMap.FETOCIDE_SELECTIVE_REDUCTION.getSNOMEDCTID(); break;
		case PROSTAGLANDIN_INJECTION : this.strSNOMEDCTID =EnumDICOMSNOMEDMap.PROSTAGLANDIN_INJECTION.getSNOMEDCTID(); break;
		}
	}

	/**
	 * Sets the value for ImageGuidedTherapeuticProcedures
	 * @param enumImageGuidedTherapeuticProcedures Object of EnumCM_ImageGuidedTherapeuticProcedures.
	 */
	public void setImageGuidedTherapeuticProcedures(EnumCM_ImageGuidedTherapeuticProcedures enumImageGuidedTherapeuticProcedures)
	{
		/**
		 * Retrieves the value for CodingSchemeDesignator, CodingSchemeVersion and Code Meaning and 
		 * sets the Code Value according to Code Meaning.
		 */
		this.strCodeMeaning = enumImageGuidedTherapeuticProcedures.getValue();
		this.strCodingSchemeDesignator = EnumCodingSchemeDesignator.SRT.getValue();
		
		/**
		 * set code Value
		 */
		setCodeValue(enumImageGuidedTherapeuticProcedures);

		/**
		 * set SNOMED-CT ID
		 */
		setSNOMEDCTID(enumImageGuidedTherapeuticProcedures);
	}
}
